from typing import Union, Tuple

import numpy as np

from gui.layer import CharactersLayer
from gui.impl.opengl import OpenGLGUIFacade
from .OpenGLLayer import OpenGLLayer


class OpenGLCharactersLayer(OpenGLLayer, CharactersLayer):

    def __init__(self, gui: OpenGLGUIFacade):
        super(OpenGLCharactersLayer, self).__init__(gui)

    def setCharacterCount(self, count: int):
        self.createFaces(count)

    def setCharacterLocation(self, charIndex: int, x: float, y: float):
        self.setFaceTileLocation(charIndex, x, y)

    def setCharacterTile(self, charIndex: int, tileX: float, tileY: float):
        self.setFaceTileTexture(charIndex, tileX, tileY)

