from state import State
from .Command import Command


class SetGroundValueCommand(Command):

    def __init__(self, state: State, regionName: str, x: int, y: int, value: int):
        self.__state = state
        self.__regionName = regionName
        self.__x = x
        self.__y = y
        self.__value = value

    def execute(self):
        region = self.__state.getRegion(self.__regionName)
        if not (0 <= self.__x < region.width and 0 <= self.__y < region.height):
            return
        if region.getGroundValue(self.__x, self.__y) == self.__value:
            return

        # Set the cell and notify
        region.setGroundValue(self.__x, self.__y, self.__value)
        self.__state.notifyRegionCellChanged(self.__regionName, self.__x, self.__y)
